Index: trunk/LMDZ.MARS/libf/phymars/physiq_mod.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/physiq_mod.F	(revision 2348)
+++ trunk/LMDZ.MARS/libf/phymars/physiq_mod.F	(revision 2349)
@@ -18,5 +18,4 @@
       use watersat_mod, only: watersat
       use co2condens_mod, only: co2condens
-      use co2condens_mod4micro, only: co2condens4micro
       use co2cloud_mod, only: co2cloud, mem_Mccn_co2, mem_Mh2o_co2,
      &                        mem_Nccn_co2
@@ -252,4 +251,6 @@
 c     Variables used by the CO2 clouds microphysical scheme:
       DOUBLE PRECISION riceco2(ngrid,nlayer)   ! co2 ice geometric mean radius (m)
+      real rsedcloudco2(ngrid,nlayer) !CO2 Cloud sedimentation radius
+      real rhocloudco2(ngrid,nlayer) !co2 Cloud density (kg.m-3)
       real zdqssed_co2(ngrid)  ! CO2 flux at the surface  (kg.m-2.s-1)
       real zcondicea_co2microp(ngrid,nlayer)
@@ -302,5 +303,5 @@
 
 c     Tendancies due to various processes:
-      REAL dqsurf(ngrid,nq)  ! tendency for tracers on surface (Kg/m2/s)
+      REAL dqsurf(ngrid,nq)
       REAL zdtlw(ngrid,nlayer)     ! (K/s)
       REAL zdtsw(ngrid,nlayer)     ! (K/s)
@@ -383,11 +384,9 @@
       REAL mtot(ngrid)          ! Total mass of water vapor (kg/m2)
       REAL mstormdtot(ngrid)    ! Total mass of stormdust tracer (kg/m2)
-      REAL mdusttot(ngrid)      ! Total mass of dust tracer (kg/m2)
+      REAL mdusttot(ngrid)    ! Total mass of dust tracer (kg/m2)
       REAL icetot(ngrid)        ! Total mass of water ice (kg/m2)
-      REAL mtotco2       ! Total mass of co2, including ice at the surface (kg/m2)
-      REAL vaptotco2     ! Total mass of co2 vapor (kg/m2)
-      REAL icetotco2     ! Total mass of co2 ice (kg/m2)
+      REAL mtotco2(ngrid)       ! Total mass of co2 vapor (kg/m2)
+      REAL icetotco2(ngrid)     ! Total mass of co2 ice (kg/m2) 
       REAL Nccntot(ngrid)       ! Total number of ccn (nbr/m2)
-      REAL NccnCO2tot(ngrid)    ! Total number of ccnCO2 (nbr/m2)
       REAL Mccntot(ngrid)       ! Total mass of ccn (kg/m2)
       REAL rave(ngrid)          ! Mean water ice effective radius (m)
@@ -404,5 +403,5 @@
       REAL DoH_ice(ngrid,nlayer) !D/H ratio
       REAL DoH_surf(ngrid) !D/H ratio surface
-
+                               
       REAL dqdustsurf(ngrid) ! surface q dust flux (kg/m2/s)
       REAL dndustsurf(ngrid) ! surface n dust flux (number/m2/s)
@@ -484,7 +483,4 @@
       real tf_clf, ntf_clf ! tf: fraction of clouds, ntf: fraction without clouds
       real rave2(ngrid), totrave2(ngrid) ! Mean water ice mean radius (m)
-C test de conservation de la masse de CO2
-      REAL co2totA
-      REAL co2totB
 
 c entrainment by slope winds above sb-grid scale topography
@@ -500,11 +496,8 @@
 
 c=======================================================================
-c---------- begin added by CM
-      pdq(:,:,:) = 0.
-c---------end added by CM
-
 
 c 1. Initialisation:
 c -----------------
+
 c  1.1   Initialisation only at first call
 c  ---------------------------------------
@@ -563,5 +556,5 @@
            ! starting without startfi.nc and with callsoil
            ! is not yet possible as soildepth default is not defined
-           if (callsoil) then
+           if (callsoil) then                     
               ! default mlayer distribution, following a power law:
               !  mlayer(k)=lay1*alpha**(k-1/2)
@@ -732,5 +725,5 @@
       dsotop(:,:)=0.
       dwatercap(:)=0
-
+      
 #ifdef DUSTSTORM
       pq_tmp(:,:,:)=0
@@ -817,14 +810,4 @@
       enddo
 
-      ! calculates the amount of co2 at the beginning of physics
-      co2totA = 0.
-      do ig=1,ngrid
-        do l=1,nlayer
-           co2totA = co2totA + (zplev(ig,l)-zplev(ig,l+1))/g*
-     &           (pq(ig,l,igcm_co2)+pq(ig,l,igcm_co2_ice)
-     &      +(pdq(ig,l,igcm_co2)+pdq(ig,l,igcm_co2_ice))*ptimestep)
-        end do
-        co2totA = co2totA + co2ice(ig)
-      end do
 c-----------------------------------------------------------------------
 c    2. Compute radiative tendencies :
@@ -869,5 +852,5 @@
      &                      pq(1:ngrid,1:nlayer,igcm_o)*
      &                      mmean(1:ngrid,1:nlayer)/mmol(igcm_o)
-
+                 
                  CALL nlte_tcool(ngrid,nlayer,zplay*9.869e-6,
      $                pt,zzlay,co2vmr_gcm, n2vmr_gcm, covmr_gcm, 
@@ -919,5 +902,5 @@
 c          ------------------
            ! callradite for the part with clouds
-           clearsky=.false. ! part with clouds for both cases CLFvarying true/false
+           clearsky=.false. ! part with clouds for both cases CLFvarying true/false 
            CALL callradite(icount,ngrid,nlayer,nq,zday,zls,pq,albedo,
      &     emis,mu0,zplev,zplay,pt,tsurf,fract,dist_sol,igout,
@@ -934,5 +917,5 @@
                ! if
                ! CLFvarying ...) ?? AP ??
-               clearsky=.true. !
+               clearsky=.true. ! 
                CALL callradite(icount,ngrid,nlayer,nq,zday,zls,pq,
      &              albedo,emis,mu0,zplev,zplay,pt,tsurf,fract,
@@ -1136,5 +1119,5 @@
      &                      pdqrds,wspeed,dsodust,dsords,dsotop,
      &                      tauref)
-
+                   
 c      update the tendencies of both dust after vertical transport
          DO l=1,nlayer
@@ -1188,7 +1171,7 @@
            hsummit(:)=14000.
          endif
-         clearatm=.true. ! stormdust is not accounted in the extra heating on top of the mountains
+         clearatm=.true. ! stormdust is not accounted in the extra heating on top of the mountains 
          nohmons=.false.
-         pdqtop(:,:,:)=0.
+         pdqtop(:,:,:)=0.  
          CALL topmons(ngrid,nlayer,nq,ptime,ptimestep,
      &                pq,pdq,pt,pdt,zplev,zplay,zzlev,
@@ -1240,5 +1223,5 @@
         CALL calldrag_noro(ngrid,nlayer,ptimestep,
      &                 zplay,zplev,pt,pu,pv,zdtgw,zdugw,zdvgw)
-
+ 
         DO l=1,nlayer
           DO ig=1,ngrid
@@ -1326,5 +1309,5 @@
             DO l=1,nlayer
               DO ig=1,ngrid
-                 pdq(ig,l,iq)=pdq(ig,l,iq)+ zdqdif(ig,l,iq)
+                 pdq(ig,l,iq)=pdq(ig,l,iq)+ zdqdif(ig,l,iq) 
               ENDDO
             ENDDO
@@ -1381,5 +1364,5 @@
 
       if(calltherm .and. .not.turb_resolved) then
-
+ 
         call calltherm_interface(ngrid,nlayer,nq,
      $ tracer,igcm_co2,
@@ -1389,5 +1372,5 @@
      $ pdu_th,pdv_th,pdt_th,pdq_th,lmax_th,zmax_th,
      $ dtke_th,zdhdif,hfmax_th,wstar,sensibFlux)
-
+     
          DO l=1,nlayer
            DO ig=1,ngrid
@@ -1398,8 +1381,8 @@
            ENDDO
         ENDDO
-
+ 
         DO ig=1,ngrid
           q2(ig,nlayer+1)=q2(ig,nlayer+1)+dtke_th(ig,nlayer+1)*ptimestep
-        ENDDO
+        ENDDO      
 
         if (tracer) then
@@ -1510,9 +1493,9 @@
      &                nq,tau,tauscaling,rdust,rice,nuice,
      &                rsedcloud,rhocloud,totcloudfrac)
-
+     
 c Temperature variation due to latent heat release
            if (activice) then
-               pdt(1:ngrid,1:nlayer) =
-     &          pdt(1:ngrid,1:nlayer) +
+               pdt(1:ngrid,1:nlayer) = 
+     &          pdt(1:ngrid,1:nlayer) + 
      &          zdtcloud(1:ngrid,1:nlayer)
            endif
@@ -1528,9 +1511,9 @@
            if (hdo) then
 ! increment HDO vapour and ice atmospheric tracers tendencies
-           pdq(1:ngrid,1:nlayer,igcm_hdo_vap) =
-     &       pdq(1:ngrid,1:nlayer,igcm_hdo_vap) +
+           pdq(1:ngrid,1:nlayer,igcm_hdo_vap) = 
+     &       pdq(1:ngrid,1:nlayer,igcm_hdo_vap) + 
      &       zdqcloud(1:ngrid,1:nlayer,igcm_hdo_vap)
-           pdq(1:ngrid,1:nlayer,igcm_hdo_ice) =
-     &       pdq(1:ngrid,1:nlayer,igcm_hdo_ice) +
+           pdq(1:ngrid,1:nlayer,igcm_hdo_ice) = 
+     &       pdq(1:ngrid,1:nlayer,igcm_hdo_ice) + 
      &       zdqcloud(1:ngrid,1:nlayer,igcm_hdo_ice)
            endif !hdo
@@ -1605,13 +1588,15 @@
 c                                nucleation
 c               imicroco2=50     micro-timestep is 1/50 of physical timestep
-        zdqssed_co2(:) = 0.
-
-         IF (co2clouds) THEN
-           call co2cloud(ngrid,nlayer,ptimestep,
+         
+         IF (co2clouds ) THEN
+
+
+            call co2cloud(ngrid,nlayer,ptimestep,
      &           zplev,zplay,pdpsrf,zzlay,pt,pdt,
      &           pq,pdq,zdqcloudco2,zdtcloudco2,
      &           nq,tau,tauscaling,rdust,rice,riceco2,nuice,
+     &           rsedcloudco2,rhocloudco2,
      &           rsedcloud,rhocloud,zzlev,zdqssed_co2,
-     &           pdu,pu,zcondicea_co2microp, co2ice)
+     &           pdu,pu,zcondicea_co2microp)
 
 
@@ -1627,23 +1612,24 @@
 ! We need to check that we have Nccn & Ndust > 0
 ! This is due to single precision rounding problems
+              
 ! increment dust tracers tendancies
-               pdq(:,:,igcm_dust_mass) = pdq(:,:,igcm_dust_mass)
-     &                                 + zdqcloudco2(:,:,igcm_dust_mass)
-
-               pdq(:,:,igcm_dust_number) = pdq(:,:,igcm_dust_number)
-     &                               + zdqcloudco2(:,:,igcm_dust_number)
-
-               pdq(:,:,igcm_co2) = pdq(:,:,igcm_co2)
-     &                             + zdqcloudco2(:,:,igcm_co2)
-
-               pdq(:,:,igcm_co2_ice) = pdq(:,:,igcm_co2_ice)
-     &                                 + zdqcloudco2(:,:,igcm_co2_ice)
-
-               pdq(:,:,igcm_ccnco2_mass) = pdq(:,:,igcm_ccnco2_mass)
-     &                               + zdqcloudco2(:,:,igcm_ccnco2_mass)
-
-               pdq(:,:,igcm_ccnco2_number) = pdq(:,:,igcm_ccnco2_number)
-     &                             + zdqcloudco2(:,:,igcm_ccnco2_number)
-
+               pdq(1:ngrid,1:nlayer,igcm_dust_mass) = 
+     &              pdq(1:ngrid,1:nlayer,igcm_dust_mass) + 
+     &              zdqcloudco2(1:ngrid,1:nlayer,igcm_dust_mass)          
+               pdq(1:ngrid,1:nlayer,igcm_dust_number) = 
+     &              pdq(1:ngrid,1:nlayer,igcm_dust_number) + 
+     &              zdqcloudco2(1:ngrid,1:nlayer,igcm_dust_number)
+               pdq(1:ngrid,1:nlayer,igcm_co2) = 
+     &              pdq(1:ngrid,1:nlayer,igcm_co2) + 
+     &              zdqcloudco2(1:ngrid,1:nlayer,igcm_co2)
+               pdq(1:ngrid,1:nlayer,igcm_co2_ice) = 
+     &              pdq(1:ngrid,1:nlayer,igcm_co2_ice) + 
+     &              zdqcloudco2(1:ngrid,1:nlayer,igcm_co2_ice)
+               pdq(1:ngrid,1:nlayer,igcm_ccnco2_mass) = 
+     &              pdq(1:ngrid,1:nlayer,igcm_ccnco2_mass) + 
+     &              zdqcloudco2(1:ngrid,1:nlayer,igcm_ccnco2_mass)
+               pdq(1:ngrid,1:nlayer,igcm_ccnco2_number) = 
+     &              pdq(1:ngrid,1:nlayer,igcm_ccnco2_number) + 
+     &              zdqcloudco2(1:ngrid,1:nlayer,igcm_ccnco2_number)
 !Update water ice clouds values as well
              if (co2useh2o) then
@@ -1657,7 +1643,5 @@
      &               pdq(1:ngrid,1:nlayer,igcm_ccn_number) + 
      &               zdqcloudco2(1:ngrid,1:nlayer,igcm_ccn_number)
-
-c     Negative values?
-                where (pq(:,:,igcm_ccn_mass) +
+                where (pq(:,:,igcm_ccn_mass) + 
      &                 ptimestep*pdq(:,:,igcm_ccn_mass) < 0.)
                   pdq(:,:,igcm_ccn_mass) = 
@@ -1666,6 +1650,5 @@
      &               - pq(:,:,igcm_ccn_number)/ptimestep + 1.e-30
                 end where
-c     Negative values?
-                where (pq(:,:,igcm_ccn_number) +
+                where (pq(:,:,igcm_ccn_number) + 
      &                 ptimestep*pdq(:,:,igcm_ccn_number) < 0.)
                   pdq(:,:,igcm_ccn_mass) = 
@@ -1706,5 +1689,6 @@
      &           - pq(:,:,igcm_dust_number)/ptimestep + 1.e-30
              end where
-      END IF ! of IF (co2clouds)
+      
+      END IF                    ! of IF (co2clouds)
 
 c   9b. Aerosol particles
@@ -1750,4 +1734,8 @@
      &                tau,tauscaling)
 c Flux at the surface of co2 ice computed in co2cloud microtimestep
+           IF (co2clouds) THEN
+              zdqssed(1:ngrid,igcm_co2_ice)=zdqssed_co2(1:ngrid)
+           ENDIF
+
            IF (rdstorm) THEN
 c             Storm dust cannot sediment to the surface
@@ -1879,5 +1867,6 @@
           DO ig=1,ngrid
             dtrad(ig,l)=dtrad(ig,l)+zdteuv(ig,l)
-            pdt(ig,l)=pdt(ig,l)+zdtconduc(ig,l)+zdteuv(ig,l)
+            pdt(ig,l)=pdt(ig,l)+zdtconduc(ig,l)
+     &                         +zdteuv(ig,l)
             pdv(ig,l)=pdv(ig,l)+zdvmolvis(ig,l)
             pdu(ig,l)=pdu(ig,l)+zdumolvis(ig,l)
@@ -1894,30 +1883,17 @@
 c     (should be the last atmospherical physical process to be computed)
 c   -------------------------------------------
+
       IF (tituscap) THEN
          !!! get the actual co2 seasonal cap from Titus observations
-         CALL geticecover(ngrid, 180.*zls/pi,
+         CALL geticecover( ngrid, 180.*zls/pi,
      .                  180.*longitude/pi, 180.*latitude/pi, co2ice )
          co2ice = co2ice * 10000.
       ENDIF
       
+      
+      pdpsrf(:) = 0
 
       IF (callcond) THEN
-         zdtc(:,:) = 0.
-         zdtsurfc(:) = 0.
-         zduc(:,:) = 0.
-         zdvc(:,:) = 0.
-         zdqc(:,:,:) = 0.
-
-        if (co2clouds) then
-          CALL co2condens4micro(ngrid,nlayer,nq,ptimestep,
-     $                  capcal,zplay,zplev,tsurf,pt,
-     $                  pphi,pdt,pdu,pdv,zdtsurf,pu,pv,pq,pdq,
-     $                  co2ice,albedo,emis,
-     $                  zdtc,zdtsurfc,pdpsrf,zduc,zdvc,zdqc,
-     $                  fluxsurf_sw,zls,
-     $                  zdqssed_co2,zcondicea_co2microp,
-     &                  zdtcloudco2)
-        else
-          CALL co2condens(ngrid,nlayer,nq,ptimestep,
+         CALL co2condens(ngrid,nlayer,nq,ptimestep,
      $              capcal,zplay,zplev,tsurf,pt,
      $              pphi,pdt,pdu,pdv,zdtsurf,pu,pv,pq,pdq,
@@ -1927,11 +1903,6 @@
      $              zdqssed_co2,zcondicea_co2microp,
      &              zdtcloudco2,zdqsc)
-           DO iq=1, nq
-           DO ig=1,ngrid
-              dqsurf(ig,iq)=dqsurf(ig,iq)+zdqsc(ig,iq)
-           ENDDO  ! (ig)
-           ENDDO    ! (iq)
-        end if
-        DO l=1,nlayer
+
+         DO l=1,nlayer
            DO ig=1,ngrid
              pdt(ig,l)=pdt(ig,l)+zdtc(ig,l)
@@ -1939,14 +1910,14 @@
              pdu(ig,l)=pdu(ig,l)+zduc(ig,l)
            ENDDO
-        ENDDO
-        DO ig=1,ngrid
-           zdtsurf(ig) = zdtsurf(ig) + zdtsurfc(ig)
-        ENDDO
-
-        IF (tracer) THEN
+         ENDDO
+         DO ig=1,ngrid
+            zdtsurf(ig) = zdtsurf(ig) + zdtsurfc(ig)
+         ENDDO
+
+         IF (tracer) THEN
            DO iq=1, nq
             DO l=1,nlayer
               DO ig=1,ngrid
-                pdq(ig,l,iq)=pdq(ig,l,iq)+ zdqc(ig,l,iq)
+                pdq(ig,l,iq)=pdq(ig,l,iq)+ zdqc(ig,l,iq) 
               ENDDO
             ENDDO
@@ -1966,4 +1937,5 @@
           ps(ig) = zplev(ig,1) + pdpsrf(ig)*ptimestep
         ENDDO
+        
         ! update pressure levels
         DO l=1,nlayer
@@ -1974,4 +1946,5 @@
         ENDDO
         zplev(:,nlayer+1) = 0.
+        
         ! update layers altitude
         DO l=2,nlayer
@@ -1983,4 +1956,5 @@
         ENDDO
 #endif
+      
       ENDIF  ! of IF (callcond)
 
@@ -1997,4 +1971,5 @@
         ENDDO    ! (iq)
       ENDIF
+      
 c-----------------------------------------------------------------------
 c   12. Surface  and sub-surface soil temperature
@@ -2099,5 +2074,5 @@
 
       DO ig=1,ngrid
-         watercap(ig)=watercap(ig)+ptimestep*dwatercap(ig)
+         watercap(ig)=watercap(ig)+ptimestep*dwatercap(ig) 
       ENDDO
 
@@ -2128,5 +2103,5 @@
       ENDDO
 
-      ! Density
+      ! Density 
       DO l=1,nlayer
          DO ig=1,ngrid
@@ -2143,18 +2118,4 @@
        ENDDO
 
-      ! Total mass of co2
-      mtotco2 = 0.
-      icetotco2 = 0.
-      vaptotco2 = 0.
-      do ig=1,ngrid
-        do l=1,nlayer
-          vaptotco2 = vaptotco2 + zq(ig,l,igcm_co2) *
-     &                    (zplev(ig,l) - zplev(ig,l+1)) / g
-          icetotco2 = icetotco2 + zq(ig,l,igcm_co2_ice) *
-     &                    (zplev(ig,l) - zplev(ig,l+1)) / g
-        end do
-        mtotco2 = mtotco2 + co2ice(ig)
-      end do
-      mtotco2 = mtotco2 + vaptotco2 + icetotco2
 
 c    Compute surface stress : (NB: z0 is a common in surfdat.h)
@@ -2289,5 +2250,5 @@
      .          icount,' date=',ztime_fin
             
-
+            
           call physdem1("restartfi.nc",nsoilmx,ngrid,nlayer,nq,
      .                ptimestep,ztime_fin,
@@ -2306,13 +2267,13 @@
          if (tracer) then
            ! Density-scaled opacities
-              do ig=1,ngrid
-                dsodust(ig,:) =
+              do ig=1,ngrid 
+                dsodust(ig,:) = 
      &                dsodust(ig,:)*tauscaling(ig)
-                dsords(ig,:) =
+                dsords(ig,:) = 
      &                dsords(ig,:)*tauscaling(ig)
                 dsotop(ig,:) =
      &                dsotop(ig,:)*tauscaling(ig)
               enddo
-
+         
            if(doubleq) then
               do ig=1,ngrid 
@@ -2372,4 +2333,17 @@
      &                zq(ig,:,igcm_ccnco2_mass)*tauscaling(ig)
               enddo
+c D. BARDET compute integrated CO2 vapor and ice content
+              mtotco2(:)=0
+              icetotco2(:)=0
+              do ig=1,ngrid 
+               do l=1,nlayer
+                 mtotco2(ig) = mtotco2(ig) + 
+     &                      zq(ig,l,igcm_co2) * 
+     &                      (zplev(ig,l) - zplev(ig,l+1)) / g
+                 icetotco2(ig) = icetotco2(ig) + 
+     &                        zq(ig,l,igcm_co2_ice) * 
+     &                        (zplev(ig,l) - zplev(ig,l+1)) / g
+               enddo
+              enddo
            endif ! of if (co2clouds)
                               
@@ -2385,5 +2359,5 @@
              ENDIF !hdo
 
-             do ig=1,ngrid
+             do ig=1,ngrid 
                do l=1,nlayer
                  mtot(ig) = mtot(ig) + 
@@ -2394,9 +2368,9 @@
      &                        (zplev(ig,l) - zplev(ig,l+1)) / g
                  IF (hdo) then
-                 mtotD(ig) = mtotD(ig) +
-     &                      zq(ig,l,igcm_hdo_vap) *
+                 mtotD(ig) = mtotD(ig) + 
+     &                      zq(ig,l,igcm_hdo_vap) * 
      &                      (zplev(ig,l) - zplev(ig,l+1)) / g
-                 icetotD(ig) = icetotD(ig) +
-     &                        zq(ig,l,igcm_hdo_ice) *
+                 icetotD(ig) = icetotD(ig) + 
+     &                        zq(ig,l,igcm_hdo_ice) * 
      &                        (zplev(ig,l) - zplev(ig,l+1)) / g
                  ENDIF !hdo
@@ -2470,5 +2444,8 @@
 
            endif ! of if (water)
+
+
         endif                   ! of if (tracer)
+
 #ifndef MESOSCALE
 c        -----------------------------------------------------------------
@@ -2849,102 +2826,107 @@
 
 #else
-      !!! this is to ensure correct initialisation of mesoscale model
-      call WRITEDIAGFI(ngrid,"tsurf","Surface temperature","K",2,
-     &                 tsurf)
-      call WRITEDIAGFI(ngrid,"ps","surface pressure","Pa",2,ps)
-      call WRITEDIAGFI(ngrid,"co2ice","co2 ice thickness","kg.m-2",2,
-     &                 co2ice)
-      call WRITEDIAGFI(ngrid,"temp","temperature","K",3,zt)
-      call WRITEDIAGFI(ngrid,"u","Zonal wind","m.s-1",3,zu)
-      call WRITEDIAGFI(ngrid,"v","Meridional wind","m.s-1",3,zv)
-      call WRITEDIAGFI(ngrid,"emis","Surface emissivity","w.m-1",2,
-     &                 emis)
-      call WRITEDIAGFI(ngrid,"tsoil","Soil temperature",
-     &                 "K",3,tsoil)
-      call WRITEDIAGFI(ngrid,"inertiedat","Soil inertia",
-     &                 "K",3,inertiedat)
+     !!! this is to ensure correct initialisation of mesoscale model
+        call WRITEDIAGFI(ngrid,"tsurf","Surface temperature","K",2,
+     &                  tsurf)
+        call WRITEDIAGFI(ngrid,"ps","surface pressure","Pa",2,ps) 
+        call WRITEDIAGFI(ngrid,"co2ice","co2 ice thickness","kg.m-2",2,
+     &                  co2ice)
+        call WRITEDIAGFI(ngrid,"temp","temperature","K",3,zt)
+        call WRITEDIAGFI(ngrid,"u","Zonal wind","m.s-1",3,zu)
+        call WRITEDIAGFI(ngrid,"v","Meridional wind","m.s-1",3,zv)
+        call WRITEDIAGFI(ngrid,"emis","Surface emissivity","w.m-1",2,
+     &                  emis)
+        call WRITEDIAGFI(ngrid,"tsoil","Soil temperature",
+     &                       "K",3,tsoil)
+        call WRITEDIAGFI(ngrid,"inertiedat","Soil inertia",
+     &                       "K",3,inertiedat)
 #endif
+
 
 c        ----------------------------------------------------------
 c        Outputs of the CO2 cycle
 c        ----------------------------------------------------------
-
-      if (tracer.and.(igcm_co2.ne.0)) then
-!       call WRITEDIAGFI(ngrid,"co2_l1","co2 mix. ratio in 1st layer",
-!    &                   "kg/kg",2,zq(1,1,igcm_co2))
-        call WRITEDIAGFI(ngrid,"co2","co2 mass mixing ratio",
-     &                   "kg/kg",3,zq(:,:,igcm_co2))
-
-        if (co2clouds) then
-          call WRITEDIAGFI(ngrid,'zdtcloudco2',
-     &                     'temperature variation of CO2 latent heat',
-     &                     'K/s',3,zdtcloudco2)
+            
+         if (tracer.and.(igcm_co2.ne.0)) then
+!          call WRITEDIAGFI(ngrid,"co2_l1","co2 mix. ratio in 1st layer",
+!    &                     "kg/kg",2,zq(1,1,igcm_co2))
+          call WRITEDIAGFI(ngrid,"co2","co2 mass mixing ratio",
+     &                     "kg/kg",3,zq(1,1,igcm_co2))
+          if (co2clouds) then
+            CALL WRITEDIAGFI(ngrid,'mtotco2',
+     &                       'total mass of CO2 vapor',
+     &                       'kg/m2',2,mtotco2)
+            CALL WRITEDIAGFI(ngrid,'zdtcloudco2',
+     &                       'temperature variation of CO2 latent heat',
+     &                       'K/s',3,zdtcloudco2)
+
+            CALL WRITEDIAGFI(ngrid,'icetotco2',
+     &                       'total mass of CO2 ice',
+     &                       'kg/m2',2,icetotco2)
  
-          call WRITEDIAGFI(ngrid,'ccnqco2','CCNco2 mass mr',
-     &                     'kg/kg',3,qccnco2)
-
-          call WRITEDIAGFI(ngrid,'ccnNco2','CCNco2 number',
-     &                     'part/kg',3,nccnco2)
-
-          call WRITEDIAGFI(ngrid,'co2_ice','co2_ice','kg/kg',
-     &                     3,zq(:,:,igcm_co2_ice))
-
-          call WRITEDIAGFI(ngrid,'precip_co2_ice',
-     &                     'surface deposition of co2 ice',
-     &                     'kg.m-2.s-1',2,
-     &                     zdqssed(1:ngrid,igcm_co2_ice))
-        end if ! of if (co2clouds)
-      end if ! of if (tracer.and.(igcm_co2.ne.0))
-
-      ! Output He tracer, if there is one
-      if (tracer.and.(igcm_he.ne.0)) then
-        call WRITEDIAGFI(ngrid,"he","helium mass mixing ratio",
-     &                   "kg/kg",3,zq(1,1,igcm_he))
-        vmr = zq(1:ngrid,1:nlayer,igcm_he)
-     &        * mmean(1:ngrid,1:nlayer)/mmol(igcm_he)
-        call WRITEDIAGFI(ngrid,'vmr_he','helium vol. mixing ratio',
-     &                   'mol/mol',3,vmr)
-      end if
+            call WRITEDIAGFI(ngrid,'ccnqco2','CCNco2 mass mr',
+     &                       'kg/kg',3,qccnco2)
+            call WRITEDIAGFI(ngrid,'ccnNco2','CCNco2 number',
+     &                       'part/kg',3,nccnco2)
+            call WRITEDIAGFI(ngrid,'co2_ice','co2_ice','kg/kg',
+     &                       3,zq(:,:,igcm_co2_ice))
+            call WRITEDIAGFI(ngrid,'precip_co2_ice',
+     &                       'surface deposition of co2 ice',
+     &                       'kg.m-2.s-1',2,
+     &                       zdqssed(1:ngrid,igcm_co2_ice))
+           endif ! of if (co2clouds)
+         endif ! of if (tracer.and.(igcm_co2.ne.0))
+        ! Output He tracer, if there is one
+        if (tracer.and.(igcm_he.ne.0)) then
+          call WRITEDIAGFI(ngrid,"he","helium mass mixing ratio",
+     &                     "kg/kg",3,zq(1,1,igcm_he))
+          vmr=zq(1:ngrid,1:nlayer,igcm_he)
+     &       *mmean(1:ngrid,1:nlayer)/mmol(igcm_he)
+          call WRITEDIAGFI(ngrid,'vmr_he','helium vol. mixing ratio',
+     &                       'mol/mol',3,vmr)
+        endif
 
 c        ----------------------------------------------------------
 c        Outputs of the water cycle
 c        ----------------------------------------------------------
-      if (tracer) then
-        if (water) then
+         if (tracer) then
+           if (water) then
+
 #ifdef MESOINI
             !!!! waterice = q01, voir readmeteo.F90
-          call WRITEDIAGFI(ngrid,'q01',noms(igcm_h2o_ice),
-     &                     'kg/kg',3,
-     &                     zq(1:ngrid,1:nlayer,igcm_h2o_ice))
+            call WRITEDIAGFI(ngrid,'q01',noms(igcm_h2o_ice),
+     &                      'kg/kg',3,
+     &                       zq(1:ngrid,1:nlayer,igcm_h2o_ice))
             !!!! watervapor = q02, voir readmeteo.F90
-          call WRITEDIAGFI(ngrid,'q02',noms(igcm_h2o_vap),
-     &                     'kg/kg',3,
-     &                     zq(1:ngrid,1:nlayer,igcm_h2o_vap))
+            call WRITEDIAGFI(ngrid,'q02',noms(igcm_h2o_vap),
+     &                      'kg/kg',3,
+     &                       zq(1:ngrid,1:nlayer,igcm_h2o_vap))
             !!!! surface waterice qsurf02 (voir readmeteo)
-          call WRITEDIAGFI(ngrid,'qsurf02','surface tracer',
-     &                     'kg.m-2',2,
-     &                     qsurf(1:ngrid,igcm_h2o_ice))
+            call WRITEDIAGFI(ngrid,'qsurf02','surface tracer',
+     &                      'kg.m-2',2,
+     &                       qsurf(1:ngrid,igcm_h2o_ice))
 #endif
-          call WRITEDIAGFI(ngrid,'mtot',
-     &                     'total mass of water vapor',
-     &                     'kg/m2',2,mtot)
-          call WRITEDIAGFI(ngrid,'icetot',
-     &                     'total mass of water ice',
-     &                     'kg/m2',2,icetot)
-          vmr = zq(1:ngrid,1:nlayer,igcm_h2o_ice)
-     &          * mmean(1:ngrid,1:nlayer)/mmol(igcm_h2o_ice)
-          call WRITEDIAGFI(ngrid,'vmr_h2oice','h2o ice vmr',
-     &                     'mol/mol',3,vmr)
-          vmr = zq(1:ngrid,1:nlayer,igcm_h2o_vap)
-     &          * mmean(1:ngrid,1:nlayer)/mmol(igcm_h2o_vap)
-          call WRITEDIAGFI(ngrid,'vmr_h2ovap','h2o vap vmr',
-     &                     'mol/mol',3,vmr)
-          call WRITEDIAGFI(ngrid,'reffice',
-     &                     'Mean reff',
-     &                     'm',2,rave)
-          call WRITEDIAGFI(ngrid,'h2o_ice','h2o_ice','kg/kg',
-     &                     3,zq(:,:,igcm_h2o_ice))
-          call WRITEDIAGFI(ngrid,'h2o_vap','h2o_vap','kg/kg',
-     &                     3,zq(:,:,igcm_h2o_vap))
+            CALL WRITEDIAGFI(ngrid,'mtot',
+     &                       'total mass of water vapor',
+     &                       'kg/m2',2,mtot)
+            CALL WRITEDIAGFI(ngrid,'icetot',
+     &                       'total mass of water ice',
+     &                       'kg/m2',2,icetot)
+            vmr=zq(1:ngrid,1:nlayer,igcm_h2o_ice)
+     &      *mmean(1:ngrid,1:nlayer)/mmol(igcm_h2o_ice)
+            CALL WRITEDIAGFI(ngrid,'vmr_h2oice','h2o ice vmr',
+     &                       'mol/mol',3,vmr)
+            vmr=zq(1:ngrid,1:nlayer,igcm_h2o_vap)
+     &      *mmean(1:ngrid,1:nlayer)/mmol(igcm_h2o_vap)
+            CALL WRITEDIAGFI(ngrid,'vmr_h2ovap','h2o vap vmr',
+     &                       'mol/mol',3,vmr)
+            CALL WRITEDIAGFI(ngrid,'reffice',
+     &                       'Mean reff',
+     &                       'm',2,rave)
+
+            call WRITEDIAGFI(ngrid,'h2o_ice','h2o_ice','kg/kg',
+     &             3,zq(:,:,igcm_h2o_ice))
+            call WRITEDIAGFI(ngrid,'h2o_vap','h2o_vap','kg/kg',
+     &             3,zq(:,:,igcm_h2o_vap))
 
             if (hdo) then
@@ -2972,5 +2954,5 @@
             do l=1,nlayer
                 do ig=1,ngrid
-                if (zq(ig,l,igcm_h2o_vap).gt.qperemin) then
+                if (zq(ig,l,igcm_h2o_vap).gt.qperemin) then 
                     DoH_vap(ig,l) = ( zq(ig,l,igcm_hdo_vap)/
      &              zq(ig,l,igcm_h2o_vap) )*1./(2.*155.76e-6)
@@ -2994,5 +2976,5 @@
             CALL WRITEDIAGFI(ngrid,'DoH_vap',
      &                       'D/H ratio in vapor',
-     &                       ' ',3,DoH_vap)
+     &                       ' ',3,DoH_vap)  
             CALL WRITEDIAGFI(ngrid,'DoH_ice',
      &                       'D/H ratio in ice',
@@ -3051,26 +3033,28 @@
               endif
 !A. Pottier
-          if (CLFvarying) then !AP14 nebulosity
-            call WRITEDIAGFI(ngrid,'totcloudfrac',
-     &                       'Total cloud fraction',
+              if (CLFvarying) then !AP14 nebulosity
+                 call WRITEDIAGFI(ngrid,'totcloudfrac',
+     &                'Total cloud fraction',
      &                       ' ',2,totcloudfrac)
-          end if !clf varying
-        end if !(water)
-
-        if (water.and..not.photochem) then
-          iq = nq
-c          write(str2(1:2),'(i2.2)') iq
-c          call WRITEDIAGFI(ngrid,'dqs'//str2,'dqscloud',
-c    &                      'kg.m-2',2,zdqscloud(1,iq))
-c          call WRITEDIAGFI(ngrid,'dqch'//str2,'var chim',
-c    &                      'kg/kg',3,zdqchim(1,1,iq))
-c          call WRITEDIAGFI(ngrid,'dqd'//str2,'var dif',
-c    &                      'kg/kg',3,zdqdif(1,1,iq))
-c          call WRITEDIAGFI(ngrid,'dqa'//str2,'var adj',
-c    &                      'kg/kg',3,zdqadj(1,1,iq))
-c          call WRITEDIAGFI(ngrid,'dqc'//str2,'var c',
-c    &                      'kg/kg',3,zdqc(1,1,iq))
-        end if  !(water.and..not.photochem)
-      end if !tracer
+              endif !clf varying
+
+           endif !(water)
+
+
+           if (water.and..not.photochem) then
+             iq=nq
+c            write(str2(1:2),'(i2.2)') iq
+c            call WRITEDIAGFI(ngrid,'dqs'//str2,'dqscloud',
+c    &                       'kg.m-2',2,zdqscloud(1,iq))
+c            call WRITEDIAGFI(ngrid,'dqch'//str2,'var chim',
+c    &                       'kg/kg',3,zdqchim(1,1,iq))
+c            call WRITEDIAGFI(ngrid,'dqd'//str2,'var dif',
+c    &                       'kg/kg',3,zdqdif(1,1,iq))
+c            call WRITEDIAGFI(ngrid,'dqa'//str2,'var adj',
+c    &                       'kg/kg',3,zdqadj(1,1,iq))
+c            call WRITEDIAGFI(ngrid,'dqc'//str2,'var c',
+c    &                       'kg/kg',3,zdqc(1,1,iq))
+           endif  !(water.and..not.photochem)
+         endif
 
 c        ----------------------------------------------------------
@@ -3078,10 +3062,10 @@
 c        ----------------------------------------------------------
 
-      call WRITEDIAGFI(ngrid,'tauref',
-     &                 'Dust ref opt depth','NU',2,tauref)
-
-      if (tracer.and.(dustbin.ne.0)) then
-
-        call WRITEDIAGFI(ngrid,'tau','taudust','SI',2,tau(1,1))
+        call WRITEDIAGFI(ngrid,'tauref',
+     &                    'Dust ref opt depth','NU',2,tauref)
+
+         if (tracer.and.(dustbin.ne.0)) then
+
+          call WRITEDIAGFI(ngrid,'tau','taudust','SI',2,tau(1,1))
 
 #ifndef MESOINI
@@ -3113,5 +3097,5 @@
              call WRITEDIAGFI(ngrid,'dustN','Dust number',
      &                        'part/kg',3,ndust)
-
+             
 	     select case (trim(dustiropacity))
               case ("tes")
@@ -3186,5 +3170,5 @@
              call WRITEDIAGFI(ngrid,'totaldustq','total dust mass',
      &                        'kg/kg',3,qdusttotal)
-
+             
 	     select case (trim(dustiropacity))
               case ("tes")
@@ -3211,5 +3195,5 @@
              end select
            endif ! (slpwind)
-
+	   
            if (scavenging) then
              call WRITEDIAGFI(ngrid,'ccnq','CCN mass mr',
